% This function cleans and loads the data generated by 2_2 into a Matlab
% .mat file and saves it to the structure "O"

function m3_1_dataInput(Header,Spec,RootDir)

P.Header    = Header;
P.Spec      = Spec;
P.StartYear = 1993;
P.EndYear   = 2007;


disp('-------------------------------------------------------------------')
disp('Running m3_1_dataInput.m...')
disp('This function cleans and loads the data generated by 2_2 into a Matlab')
disp('.mat file and saves it to the structure "O"')
fprintf('\n')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('-------------------------------------------------------------------')

cd('../data/')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Section 3.1.1: Load Data %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('Section 3.1.1: Load Data')
disp('Loading txt data from 2_2_liab_impute.do...')
disp('Sorted by id, start year of spell, start month of spell')
fprintf('\n')
%Load all the variables
%Presorted by ID,start_year,start_month

varlist = dir('*.txt');
for i1 = 1:numel(varlist)
    load(varlist(i1).name);
    disp(varlist(i1).name);
    eval(['Temp  = ',varlist(i1).name(1:end-4),';']);
    eval(['O.',varlist(i1).name(8+numel(P.Header)+2:end-4),'= Temp;']);
    eval(['clear ',varlist(i1).name(1:end-4),';']);
end

%Record original id to for error checking
%(state, any other statuses, etc)
%This also allows us to compare across the two periods.
O.idnumorig = O.idnum;
O.idorig    = O.id;
fprintf('\n')
disp('Saving data to men19932007.mat...')

save([RootDir,'\data\',P.Header,num2str(P.StartYear),num2str(P.EndYear),'_',P.Spec,'.mat'],'O','-v7.3');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('-------------------------------------------------------------------')


fprintf('\n')
disp('m3_1_dataInput.m completed successfully and log closed.')

% End logging.
fclose(fopen([RootDir,'\log\done.done'],'w+'));
exit
end

